// Copyright 2016 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetDeploymentParams creates a new GetDeploymentParams object
// with the default values initialized.
func NewGetDeploymentParams() *GetDeploymentParams {
	var ()
	return &GetDeploymentParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetDeploymentParamsWithTimeout creates a new GetDeploymentParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetDeploymentParamsWithTimeout(timeout time.Duration) *GetDeploymentParams {
	var ()
	return &GetDeploymentParams{

		timeout: timeout,
	}
}

// NewGetDeploymentParamsWithContext creates a new GetDeploymentParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetDeploymentParamsWithContext(ctx context.Context) *GetDeploymentParams {
	var ()
	return &GetDeploymentParams{

		Context: ctx,
	}
}

/*GetDeploymentParams contains all the parameters to send to the API endpoint
for the get deployment operation typically these are written to a http.Request
*/
type GetDeploymentParams struct {

	/*ID
	  ID of deployment

	*/
	ID string
	/*Name
	  Name of environment

	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get deployment params
func (o *GetDeploymentParams) WithTimeout(timeout time.Duration) *GetDeploymentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get deployment params
func (o *GetDeploymentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get deployment params
func (o *GetDeploymentParams) WithContext(ctx context.Context) *GetDeploymentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get deployment params
func (o *GetDeploymentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithID adds the id to the get deployment params
func (o *GetDeploymentParams) WithID(id string) *GetDeploymentParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get deployment params
func (o *GetDeploymentParams) SetID(id string) {
	o.ID = id
}

// WithName adds the name to the get deployment params
func (o *GetDeploymentParams) WithName(name string) *GetDeploymentParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get deployment params
func (o *GetDeploymentParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *GetDeploymentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
