// Copyright 2016 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"net/http"
	"time"

	"golang.org/x/net/context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewGetEnvironmentParams creates a new GetEnvironmentParams object
// with the default values initialized.
func NewGetEnvironmentParams() *GetEnvironmentParams {
	var ()
	return &GetEnvironmentParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewGetEnvironmentParamsWithTimeout creates a new GetEnvironmentParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewGetEnvironmentParamsWithTimeout(timeout time.Duration) *GetEnvironmentParams {
	var ()
	return &GetEnvironmentParams{

		timeout: timeout,
	}
}

// NewGetEnvironmentParamsWithContext creates a new GetEnvironmentParams object
// with the default values initialized, and the ability to set a context for a request
func NewGetEnvironmentParamsWithContext(ctx context.Context) *GetEnvironmentParams {
	var ()
	return &GetEnvironmentParams{

		Context: ctx,
	}
}

/*GetEnvironmentParams contains all the parameters to send to the API endpoint
for the get environment operation typically these are written to a http.Request
*/
type GetEnvironmentParams struct {

	/*Name
	  Name of environment

	*/
	Name string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the get environment params
func (o *GetEnvironmentParams) WithTimeout(timeout time.Duration) *GetEnvironmentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get environment params
func (o *GetEnvironmentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get environment params
func (o *GetEnvironmentParams) WithContext(ctx context.Context) *GetEnvironmentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get environment params
func (o *GetEnvironmentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithName adds the name to the get environment params
func (o *GetEnvironmentParams) WithName(name string) *GetEnvironmentParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the get environment params
func (o *GetEnvironmentParams) SetName(name string) {
	o.Name = name
}

// WriteToRequest writes these params to a swagger request
func (o *GetEnvironmentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	r.SetTimeout(o.timeout)
	var res []error

	// path param name
	if err := r.SetPathParam("name", o.Name); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
