// Copyright 2016 Amazon.com, Inc. or its affiliates. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License"). You may
// not use this file except in compliance with the License. A copy of the
// License is located at
//
//     http://aws.amazon.com/apache2.0/
//
// or in the "license" file accompanying this file. This file is distributed
// on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
// express or implied. See the License for the specific language governing
// permissions and limitations under the License.

package operations

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/blox/blox/daemon-scheduler/generated/v1/models"
)

// GetEnvironmentReader is a Reader for the GetEnvironment structure.
type GetEnvironmentReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetEnvironmentReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {

	case 200:
		result := NewGetEnvironmentOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil

	case 400:
		result := NewGetEnvironmentBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	case 404:
		result := NewGetEnvironmentNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewGetEnvironmentOK creates a GetEnvironmentOK with default headers values
func NewGetEnvironmentOK() *GetEnvironmentOK {
	return &GetEnvironmentOK{}
}

/*GetEnvironmentOK handles this case with default header values.

OK
*/
type GetEnvironmentOK struct {
	Payload *models.Environment
}

func (o *GetEnvironmentOK) Error() string {
	return fmt.Sprintf("[GET /environments/{name}][%d] getEnvironmentOK  %+v", 200, o.Payload)
}

func (o *GetEnvironmentOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.Environment)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnvironmentBadRequest creates a GetEnvironmentBadRequest with default headers values
func NewGetEnvironmentBadRequest() *GetEnvironmentBadRequest {
	return &GetEnvironmentBadRequest{}
}

/*GetEnvironmentBadRequest handles this case with default header values.

Bad Request
*/
type GetEnvironmentBadRequest struct {
	Payload string
}

func (o *GetEnvironmentBadRequest) Error() string {
	return fmt.Sprintf("[GET /environments/{name}][%d] getEnvironmentBadRequest  %+v", 400, o.Payload)
}

func (o *GetEnvironmentBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetEnvironmentNotFound creates a GetEnvironmentNotFound with default headers values
func NewGetEnvironmentNotFound() *GetEnvironmentNotFound {
	return &GetEnvironmentNotFound{}
}

/*GetEnvironmentNotFound handles this case with default header values.

Resource not found
*/
type GetEnvironmentNotFound struct {
	Payload string
}

func (o *GetEnvironmentNotFound) Error() string {
	return fmt.Sprintf("[GET /environments/{name}][%d] getEnvironmentNotFound  %+v", 404, o.Payload)
}

func (o *GetEnvironmentNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// response payload
	if err := consumer.Consume(response.Body(), &o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
